      *SET IBMCOMP NOTRUNC
       IDENTIFICATION DIVISION.
       PROGRAM-ID.    NBRTSTC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: NBRTSTC1.CBL
      *****************************************************************
      *
      * NBRTSTC1 - A Focus on COMP, COMP-3 and COMP-5 Numeric Fields.
      *
      *
      * DESCRIPTION
      * -----------
      * This set of programs is used to show the various internal
      * format used with COMP, COMP-3 and COMP-5 fields.
      *
      * It will show actual hex-dump content of the fields.
      *
      * The COBOL programs are compiled with the ASSIGN(EXTERNAL)
      * directive. This provides for external file mapping of file
      * names.
      *
      * To run with Net Express the IBMCOMP and NOTRUNC directives
      * will be required to maintain compatability with the mainframe
      * format and field sizes for binary fields.
      *
      * This program will run on a Personal Computer with Windows
      * and Micro Focus Net Express.
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1996/03/15 Simmons, Created program.
      * 1996/03/15 Simmons, No changes to date.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* NBRTSTC1 '.
           05  T2 pic X(34) value 'COMP, COMP-3 and COMP-5 Numbers   '.
           05  T3 pic X(10) value ' v11.12.04'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* NBRTSTC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* NBRTSTC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* NBRTSTC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************

       01  NUMBERS-01.
           05  NBR-COMP.
               15  FILLER      pic X(8)    value 'COMP===='.
               15  NBS-07      pic 9(7)    COMP    value 4671.
               15  FILLER      pic X(4)    value '=END'.
           05  NBR-COMP-3.
               15  FILLER      pic X(8)    value 'COMP-3=='.
               15  NPS-07      pic 9(7)    COMP-3  value 123.
               15  FILLER      pic X(4)    value '=END'.
           05  NBR-COMP-5.
               15  FILLER      pic X(8)    value 'COMP-5=='.
               15  N5S-07      pic 9(7)    COMP-5  value 1058144256.
               15  FILLER      pic X(4)    value '=END'.

       01  LENGTHS-01.
           05  NBR-LENGTH-COMP.
               15  FILLER      pic X(12)   value 'Size/COMP==='.
               15  NBS-07-L    pic 9(4)    value 0.
           05  NBR-LENGTH-COMP-3.
               15  FILLER      pic X(12)   value 'Size/COMP-3='.
               15  NPS-07-L    pic 9(4)    value 0.
           05  NBR-LENGTH-COMP-5.
               15  FILLER      pic X(12)   value 'Size/COMP-5='.
               15  N5S-07-L    pic 9(4)    value 0.

       01  WK-SIZE             pic 9(5)    value 0.

        copy PASSDUMP.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           add length of NPS-07 to ZERO giving NPS-07-L
           add length of NBS-07 to ZERO giving NBS-07-L
           add length of N5S-07 to ZERO giving N5S-07-L

           perform DUMP-USING-MEMORY-FORMAT

           perform Z-THANK-YOU

           GOBACK.

      *****************************************************************
       DUMP-USING-MEMORY-FORMAT.
           move 'NOTE' to SIMODUMP-REQUEST
           move 'OPR1' to SIMODUMP-OUTPUT
           move 'NBRTSTC1' to SIMODUMP-DUMP-ID
           add  4 to ZERO giving SIMODUMP-RESULT
           add 96 to ZERO giving SIMODUMP-LENGTH
           call 'SIMODUMP' using SIMODUMP-PASS-AREA SIMODUMP-BUFFER

           move 'DUMP' to SIMODUMP-REQUEST
           move NUMBERS-01 to SIMODUMP-BUFFER
           add length of NUMBERS-01 to ZERO giving WK-SIZE
           move LENGTHS-01 to SIMODUMP-BUFFER(WK-SIZE + 1:WK-SIZE)
           call 'SIMODUMP' using SIMODUMP-PASS-AREA SIMODUMP-BUFFER
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE     upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *           This routine was generated by SimoREC1              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *  Generation Date: 2009/11/24  Generation Time: 12:08:01:28    *
      *****************************************************************
