       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SIMODUMP.
      *AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: SIMODUMP.CBL
      * Copy Files:    PASSDUMP.CPY
      *                HEXTABLE.CPY
      * Calls to:      SIMOLOGS is optional
      *****************************************************************
      *
      * SIMODUMP - Call SIMOLOGS to build hexadecimal dump information.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to EXECUTE, RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This set of programs illustrate the use of COBOL for displaying
      * a data buffer in hexadecimal format.
      *
      *          ************
      *          * CBLHBXJ1 *
      *          ********jcl*
      *               *
      *          ************
      *          * CBLHBXC1 *
      *          ********cbl*
      *               *
      *          ************     ************      ************
      *          * CBLHBXC1 *-----* SIMODUMP *-----* CONSOLE  *
      *          ********cbl*     ********cbl*      ******dsply*
      *                                *
      *                                *
      *                           ************     ************
      *                           * SIMOLOGS *-----* CBLHBXD1 *
      *                           ********cbl*     *******file*
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for COBOL/2.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* SIMODUMP '.
           05  T2 pic X(34) value 'COBOL Hexadecimal Dump Routine    '.
           05  T3 pic X(10) value ' v16.06.15'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* SIMODUMP '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *    ------------------------------------------------------------
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(011)  value '* SIMODUMP '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(068)  value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.
       01  MSG-LSB                 pic 9(3)    value 256.

      *****************************************************************
      *    Buffer used for posting dump information to the console.
      *    ------------------------------------------------------------
       01  DUMP-BUFFER.
           05  DUMP-TEXT           pic X(79).

      *****************************************************************

       01  TWO-BYTES.
           05  TWO-BYTES-01        pic X.
           05  TWO-BYTES-02        pic X.
       01  TWO-BYTES-BINARY        redefines   TWO-BYTES
                                   pic S9(3)   comp.

       01  IX-0           pic 9999 value 0.
       01  IX-1           pic 9999 value 0.
       01  IX-2           pic 9999 value 0.
       01  IX-3           pic 9999 value 0.
       01  IX-4           pic 9999 value 0.
       01  IX-5           pic 9999 value 0.

       01  IP-1           pic 9(5) value 0.
       01  IP-2           pic 9(5) value 0.

       01  POSITION-PTR   pic 9(7) value 0.
       01  LOOP-QUIT      pic X    value 'N'.

       01  WA-4                    pic X(4)      value LOW-VALUES.
       01  WA-5                    pic X(5)      value is SPACES.
       01  WA-8                    pic X(9)      value '00000000'.

       01  BUFFER-SIZE-LIMIT-GROUP.
           05  BUFFER-SIZE-LIMIT   pic 9(5)      value 128.
       01  BUFFER-LENGTH           pic 9999      value 0.
       01  LINE-LENGTH             pic 9999      value 0.

       01  DUMP-HEADER.
      *    05  filler pic X value '*'.
           05  filler pic X value ' '.
           05  H1 pic X(8)  value 'Position'.
           05  filler pic X value ' '.
           05  H2 pic X(35) value 'Hex..... ........ ........ ........'.
           05  filler pic X value ' '.
           05  H3 pic X(16) value 'ebcdic..........'.
           05  filler pic X value ' '.
           05  H4 pic X(16) value 'ascii...........'.

       01  DUMP-LINE.
      *    05  filler pic X value '*'.
           05  filler pic X value ' '.
           05  D1 pic X(8)  value ' x00-x0F'.
           05  filler pic X value ' '.
           05  D2 pic X(35) value 'xxxxxxxx xxxxxxxx xxxxxxxx xxxxxxxx'.
           05  filler pic X value ' '.
           05  D3 pic X(16) value '................'.
           05  filler pic X value ' '.
           05  D4 pic X(16) value '................'.

       01  X-DUMP-LINE.
      *    05  filler pic X value '*'.
           05  filler pic X value ' '.
           05  X1 pic X(8)  value ' x00-x0F'.
           05  filler pic X value ' '.
           05  X2 pic X(35) value 'xxxxxxxx xxxxxxxx xxxxxxxx xxxxxxxx'.
           05  filler pic X value ' '.
           05  X3 pic X(16) value '................'.
           05  filler pic X value ' '.
           05  X4 pic X(16) value '................'.

       01  ADDRESS-OFFSET-HEX.
           05  A0 pic X(8)  value ' x00-x0F'.
           05  A1 pic X(8)  value ' x10-x1F'.
           05  A2 pic X(8)  value ' x20-x2F'.
           05  A3 pic X(8)  value ' x30-x3F'.
           05  A4 pic X(8)  value ' x40-x4F'.
           05  A5 pic X(8)  value ' x50-x5F'.
           05  A6 pic X(8)  value ' x60-x6F'.
           05  A7 pic X(8)  value ' x70-x7F'.

       01  ADDRESS-OFFSET-DEC.
           05  B0 pic X(8)  value '   1-016'.
           05  B1 pic X(8)  value '  17-032'.
           05  B2 pic X(8)  value '  33-048'.
           05  B3 pic X(8)  value '  49-064'.
           05  B4 pic X(8)  value '  65-080'.
           05  B5 pic X(8)  value '  81-096'.
           05  B6 pic X(8)  value '  97-112'.
           05  B7 pic X(8)  value ' 113-128'.

       01  DUMP-STATUS-LINE.
           05  DS-DUMP-STATUS  pic X(08) value 'Starting'.
           05  filler          pic X(2)  value ', '.
           05  filler          pic X(15) value 'SIMODUMP-ID is '.
           05  DS-DUMP-ID      pic X(8)  value 'HEXDUMP1'.
           05  filler          pic X(2)  value ', '.
           05  filler          pic X(20) value 'Dump Buffer size is '.
           05  DS-LENGTH       pic 9999  value 0.

       01  MESSAGE-0004-1.
           05  filler pic X(9)  value 'Warning, '.
           05  filler pic X(29) value 'SIMODUMP-LENGTH is invalid,  '.
           05  filler pic X(29) value 'must be value from 1 to 128. '.
       01  MESSAGE-0004-2.
           05  filler pic X(9)  value 'Warning, '.
           05  filler pic X(29) value 'Assuming length of 128 bytes.'.

       01  MESSAGE-0008-1.
           05  filler pic X(9)  value 'Warning, '.
           05  filler pic X(24) value 'SIMODUMP-OUTPUT must be '.
           05  filler pic X(12) value 'OUT1, OUT2, '.
           05  filler pic X(19) value 'OPR1, OPR2 or LOG1.'.
       01  MESSAGE-0008-2.
           05  filler pic X(9)  value 'Warning, '.
           05  filler pic X(22) value 'Assuming OUT1 mode.'.

       01  FIRST-TIME                  pic X    value 'Y'.
       01  USR-PTR-GROUP.
           05  USR-PTR-VALUE           usage is pointer.
       01  USR-PTR-LENGTH              pic 99   value 0.
       01  USR-PTR-DUMP-ADDR           pic X(8) value '00000000'.

       01  HEX-OFFSET-GROUP.
           05  HEX-OFFSET-VALUE        pic 9(9) comp.
       01  HEX-OFFSET-LENGTH           pic 99   value 0.
       01  HEX-OFFSET-DUMP-ADDR        pic X(8) value '00000000'.

       01  DEC-POSITION-GROUP.
           05  DEC-POSITION-VALUE      pic 9(8).
       01  DEC-POSITION-LENGTH         pic 99   value 0.

       01  ADDRESS-DUMP-FMT-64.
           05  ADDRESS-DUMP-FMT-32A    pic X(8) value '00000000'.
           05  ADDRESS-DUMP-FMT-32B    pic X(8) value '00000000'.

      *****************************************************************
      *    Pass area for call SIMOLOGS.
      *    ------------------------------------------------------------
       COPY PASSLOGS.

       COPY HEXTABLE.

      *****************************************************************
       LINKAGE SECTION.
       COPY PASSDUMP.

      *****************************************************************
       PROCEDURE DIVISION using SIMODUMP-PASS-AREA, SIMODUMP-BUFFER.
           if  FIRST-TIME = 'Y'
               perform FIRST-TIME-PROCESSING
           end-if

           evaluate SIMODUMP-REQUEST
               when 'NOTE' perform ACTION-IS-POST-TEXT-INFO
               when 'DUMP' perform ACTION-IS-POST-DUMP-INFO
               when 'USER' perform ACTION-IS-POST-USER-INFO
               when other  move 'DUMP' to SIMODUMP-REQUEST
                           perform ACTION-IS-POST-DUMP-INFO
           end-evaluate
           GOBACK.

      *****************************************************************
       ACTION-IS-POST-TEXT-INFO.
           move SIMODUMP-DUMP-ID      to MESSAGE-TEXT
           move SIMODUMP-BUFFER(1:68) to MESSAGE-TEXT(10:68)
           perform Z-DISPLAY-MESSAGE-BUFFER
           exit.

      *****************************************************************
       ACTION-IS-POST-DUMP-INFO.
           perform EDIT-PASS-AREA

           set USR-PTR-VALUE to address of SIMODUMP-BUFFER
           move ZERO to HEX-OFFSET-VALUE
           add 1 to ZERO giving DEC-POSITION-VALUE

           move USR-PTR-GROUP to WA-4
           perform ADDRESS-FORMATTING
           move WA-8 to USR-PTR-DUMP-ADDR
           move WA-8 to ADDRESS-DUMP-FMT-32B

           display '* SIMODUMP ADDR is ' ADDRESS-DUMP-FMT-64

           if  SIMODUMP-OUTPUT = 'LOG1'
           or                  = 'OUT1'
           or                  = 'OUT2'
           or                  = 'OPR1'
           or                  = 'OPR2'
               move 'Starting'       to DS-DUMP-STATUS
               move SIMODUMP-DUMP-ID to DS-DUMP-ID
               move SIMODUMP-LENGTH  to DS-LENGTH
               move DUMP-STATUS-LINE to MESSAGE-TEXT
               perform Z-POST-MESSAGE-BUFFER
               move DUMP-HEADER to MESSAGE-TEXT
               perform Z-POST-MESSAGE-TEXT
           end-if

           perform DUMP-PROCESSING

      *    move SIMOLOGS-REQUEST to SIMODUMP-OUTPUT
           move SIMOLOGS-STATUS  to SIMODUMP-RESULT

           exit.

      *****************************************************************
       ACTION-IS-POST-USER-INFO.

           if  SIMODUMP-BUFFER(1:7) = 'FORMAT='
               evaluate SIMODUMP-BUFFER(8:8)
                 when 'ADDRESS ' move ' Address' to H1
                 when 'POSITION' move 'Position' to H1
                 when 'OFFSET  ' move '  Offset' to H1
               end-evaluate
           end-if
           if SIMODUMP-BUFFER(1:6) = 'LIMIT='
              perform until SIMODUMP-BUFFER(11:1) not = SPACE
                if SIMODUMP-BUFFER(11:1) = ' '
                   move SIMODUMP-BUFFER(10:1) to SIMODUMP-BUFFER(11:1)
                   move SIMODUMP-BUFFER(09:1) to SIMODUMP-BUFFER(10:1)
                   move SIMODUMP-BUFFER(08:1) to SIMODUMP-BUFFER(09:1)
                   move SIMODUMP-BUFFER(07:1) to SIMODUMP-BUFFER(08:1)
                   move ZERO to SIMODUMP-BUFFER(7:1)
                end-if
               end-perform
               move SIMODUMP-BUFFER(7:5) to BUFFER-SIZE-LIMIT-GROUP
               if BUFFER-SIZE-LIMIT is NUMERIC
                  move 'Accepted User Request, increase Buffer Size '
                    to MESSAGE-TEXT
                  move 'maximum limit to '     to MESSAGE-TEXT(45:17)
                  move BUFFER-SIZE-LIMIT-GROUP to MESSAGE-TEXT(62:5)
                  perform Z-POST-MESSAGE-BUFFER
               else
                  add 128 to ZERO giving BUFFER-SIZE-LIMIT
                  move 'Rejected User Request to increase Buffer '
                    to MESSAGE-TEXT
                  move 'Size maximum, reset to ' to MESSAGE-TEXT(42:23)
                  move BUFFER-SIZE-LIMIT-GROUP to MESSAGE-TEXT(64:5)
                  perform Z-POST-MESSAGE-BUFFER
               end-if
           end-if
           exit.

       ACTION-IS-POST-USER-INFO-OLD.
           move DUMP-HEADER to MESSAGE-TEXT
           move '*     Pos' to MESSAGE-TEXT(1:9)
           move '* ....Pos' to MESSAGE-TEXT(1:9)
           perform Z-POST-MESSAGE-TEXT

           move SPACES to D1
           add 1 to ZERO giving POSITION-PTR
           move 'N' to LOOP-QUIT

           add 1 to ZERO giving IX-1
           perform until LOOP-QUIT = 'Y'
             add 1 to ZERO giving IX-2
             add 1 to ZERO giving IX-3
             add 1 to ZERO giving IX-4
             if  SIMODUMP-LENGTH - IX-1 > 16
                 add 16 to ZERO giving LINE-LENGTH
             else
                 compute LINE-LENGTH = SIMODUMP-LENGTH - IX-1 + 1
                 move 'Y' to LOOP-QUIT
             end-if
      *      display 'DEBUG ' SIMODUMP-LENGTH ' ' LINE-LENGTH ' ' IX-1
             move X2 to D2
             move X3 to D3
             move X4 to D4
             perform until LINE-LENGTH = 0
      *        Get table element
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move SIMODUMP-BUFFER(IX-1:1) to TWO-BYTES-02
               add TWO-BYTES-BINARY to 1 giving IX-5
               move TAB-X1(IX-5) to WA-5
               move WA-5(1:2) to D2(IX-2:2)
      *        Increment to next position in hex-dump area of buffer
               add 2 to IX-2
               if  IX-2 = 9
               or  IX-2 = 18
               or  IX-2 = 27
                   add 1 to IX-2
               end-if
      *        EBCDIC Print Character and increment to next position
               move WA-5(3:1) to D3(IX-3:1)
               add 1 to IX-3
      *        ASCII  Print Character and increment to next position
               move WA-5(4:1) to D4(IX-4:1)
               add 1 to IX-4
      *        Increment pointer to next input buffer byte
               add 1 to IX-1
               subtract 1 from LINE-LENGTH
             end-perform
      *
             move POSITION-PTR to D1
             move DUMP-LINE to MESSAGE-TEXT
             perform Z-POST-MESSAGE-TEXT
             add 16 to POSITION-PTR
           end-perform
           exit.

      *****************************************************************
       ADDRESS-FORMATTING.
           add 1 to ZERO giving IP-1
           add 1 to ZERO giving IP-2
           perform 4 times
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move WA-4(IP-1:1) to TWO-BYTES-02
               add TWO-BYTES-BINARY to 1 giving IX-5
               move TAB-X1(IX-5) to WA-5
               move WA-5(1:2) to WA-8(IP-2:2)
               add 1 to IP-1
               add 2 to IP-2
           end-perform
           exit.

      *****************************************************************
       DUMP-PROCESSING.
           add 1 to ZERO giving IX-0
           add 1 to ZERO giving IX-1
           add 1 to ZERO giving IX-5
           subtract SIMODUMP-IDX from SIMODUMP-IDX
           add SIMODUMP-LENGTH to ZERO giving BUFFER-LENGTH
           if  BUFFER-LENGTH greater than 15
               add 16 to ZERO giving LINE-LENGTH
           else
               add BUFFER-LENGTH to ZERO giving LINE-LENGTH
           end-if
           perform until BUFFER-LENGTH = 0
               add 1 to ZERO giving IX-2
               add 1 to ZERO giving IX-3
               add 1 to ZERO giving IX-4
               move X-DUMP-LINE to DUMP-LINE
               move DEC-POSITION-GROUP to D1
               evaluate H1
                 when ' Address' move USR-PTR-GROUP         to WA-4
                                 perform ADDRESS-FORMATTING
                                 move WA-8                  to D1
                 when '  Offset' move HEX-OFFSET-GROUP      to WA-4
                                 perform ADDRESS-FORMATTING
                                 move WA-8                  to D1
               end-evaluate
               add 8 to IX-0
               perform DUMP-SINGLE-LINE
               if  BUFFER-LENGTH greater than 15
                   subtract 16 from BUFFER-LENGTH
                   set USR-PTR-VALUE up by 16
                   add 16 to HEX-OFFSET-VALUE
                   add 16 to DEC-POSITION-VALUE
               else
                   subtract BUFFER-LENGTH from BUFFER-LENGTH
                   set USR-PTR-VALUE to address of SIMODUMP-BUFFER
                   move ZERO to HEX-OFFSET-VALUE
                   add 1 to ZERO giving DEC-POSITION-VALUE
               end-if
               if  BUFFER-LENGTH greater than 15
                   add 16 to ZERO giving LINE-LENGTH
               else
                   add BUFFER-LENGTH to ZERO giving LINE-LENGTH
               end-if
           end-perform

           exit.

      *****************************************************************
       DUMP-SINGLE-LINE.
           perform until LINE-LENGTH = 0
      *        Get table element
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move SIMODUMP-BUFFER(IX-1:1) to TWO-BYTES-02
               add TWO-BYTES-BINARY to 1 giving IX-5
               move TAB-X1(IX-5) to WA-5
               move WA-5(1:2) to D2(IX-2:2)
      *        Increment to next position in hex-dump area of buffer
               add 2 to IX-2
               if  IX-2 = 9
               or  IX-2 = 18
               or  IX-2 = 27
                   add 1 to IX-2
               end-if
      *        EBCDIC Print Character and increment to next position
               move WA-5(3:1) to D3(IX-3:1)
               add 1 to IX-3
      *        ASCII  Print Character and increment to next position
               move WA-5(4:1) to D4(IX-4:1)
               add 1 to IX-4
      *        Increment pointer to next input buffer byte
               add 1 to IX-1
               subtract 1 from LINE-LENGTH
           end-perform
           move DUMP-LINE to DUMP-TEXT
           if  SIMODUMP-IDX < 8
               add 1 to SIMODUMP-IDX
               move DUMP-LINE to SIMODUMP-LINES(SIMODUMP-IDX)
           end-if

           if  SIMODUMP-OUTPUT = 'LOG1'
           or                  = 'OUT2'
           or                  = 'OPR2'
               move DUMP-LINE to SIMOLOGS-MESSAGE
               perform POST-TO-LOG-FILE
           else
               move DUMP-LINE to MESSAGE-TEXT
               perform Z-POST-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       EDIT-PASS-AREA.
           perform EDIT-PASS-AREA-SYSOUT
           perform EDIT-PASS-AREA-LENGTH
           exit.

       EDIT-PASS-AREA-LENGTH.
           subtract SIMODUMP-RESULT from SIMODUMP-RESULT

           if  SIMODUMP-LENGTH not NUMERIC
               add 128 to ZERO giving SIMODUMP-LENGTH
               add 4 to ZERO giving SIMODUMP-RESULT
           end-if

           if  SIMODUMP-LENGTH less than 1
           or  SIMODUMP-LENGTH greater than BUFFER-SIZE-LIMIT
               add 4 to ZERO giving SIMODUMP-RESULT
               add 128 to ZERO giving SIMODUMP-LENGTH
           end-if

           if  SIMODUMP-RESULT not = ZERO
               move MESSAGE-0004-1 to MESSAGE-TEXT
               perform Z-POST-MESSAGE-BUFFER
               move MESSAGE-0004-2 to MESSAGE-TEXT
               perform Z-POST-MESSAGE-BUFFER
           end-if

           exit.

       EDIT-PASS-AREA-SYSOUT.
           if  SIMODUMP-OUTPUT = 'NONE'
           or                  = 'OUT1'
           or                  = 'OUT2'
           or                  = 'OPR1'
           or                  = 'OPR2'
           or                  = 'LOG1'
               subtract SIMODUMP-RESULT from SIMODUMP-RESULT
           else
               add 4 to ZERO   giving SIMODUMP-RESULT
               move 'OPR1'     to     SIMODUMP-OUTPUT
               move MESSAGE-0008-1 to MESSAGE-TEXT
               perform Z-POST-MESSAGE-BUFFER
               move MESSAGE-0008-2 to MESSAGE-TEXT
               perform Z-POST-MESSAGE-BUFFER
           end-if
           exit.

      *****************************************************************
       FIRST-TIME-PROCESSING.
           add 8 to ZERO giving SIMODUMP-RESULT

           if  SIMODUMP-COPYRIGHT not = 'HIDE'
               perform POST-COPYRIGHT
           end-if

           add 1 to ZERO giving SIMODUMP-IDX
           perform 8 times
               move SPACES to SIMODUMP-LINES(SIMODUMP-IDX)
               add 1 to SIMODUMP-IDX
           end-perform
           subtract SIMODUMP-IDX from SIMODUMP-IDX
           move 'N' to FIRST-TIME
           exit.

      *****************************************************************
       POST-COPYRIGHT.
           move SIM-TITLE to     MESSAGE-TEXT
           perform        Z-POST-MESSAGE-TEXT
           move SIM-COPYRIGHT to MESSAGE-TEXT
           perform        Z-POST-MESSAGE-TEXT
           exit.

      *****************************************************************
       POST-TO-LOG-FILE.
           add  16 to ZERO giving SIMOLOGS-STATUS
      *    move DUMP-BUFFER to SIMOLOGS-MESSAGE
           call 'SIMOLOGS' using SIMOLOGS-PASS-AREA
           if  SIMOLOGS-STATUS not = ZERO
               move 'OPR1' to SIMODUMP-OUTPUT
               add SIMOLOGS-STATUS to ZERO giving SIMODUMP-RESULT
           end-if
           exit.

      *****************************************************************
       Z-DISPLAY-MESSAGE-BUFFER.
           perform Z-CALCULATE-MSG-LENGTH
           if  SIMODUMP-OUTPUT(1:3) = 'OUT'
               display MESSAGE-BUFFER(1:MSG-LSB)
           else
               display MESSAGE-BUFFER(1:MSG-LSB) upon console
           end-if
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-POST-MESSAGE-BUFFER.
           evaluate SIMODUMP-OUTPUT(1:4)
             when 'OUT1' perform Z-POST-MESSAGE-BUFFER-2-SYSOUT
             when other  perform Z-POST-MESSAGE-BUFFER-2-SYSOUT
           end-evaluate
           exit.

      *****************************************************************
       Z-POST-MESSAGE-TEXT.
           evaluate SIMODUMP-OUTPUT(1:4)
             when 'OUT1' perform Z-POST-MESSAGE-TEXT-TO-SYSOUT
             when other  perform Z-POST-MESSAGE-TEXT-TO-SYSOUT
           end-evaluate
           exit.

      *****************************************************************
       Z-POST-MESSAGE-BUFFER-2-SYSOUT.
           perform Z-CALCULATE-MSG-LENGTH
           display MESSAGE-BUFFER(1:MSG-LSB)
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-POST-MESSAGE-TEXT-TO-SYSOUT.
           perform Z-CALCULATE-MSG-LENGTH
           display MESSAGE-TEXT(1:MSG-LSB - 11)
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-CALCULATE-MSG-LENGTH.
           add 267 to ZERO giving MSG-LSB
           if  MESSAGE-TEXT-2 = SPACES
               subtract 188 from MSG-LSB
           else
               perform until MSG-LSB < 12
                          or MESSAGE-BUFFER(MSG-LSB:1) not = SPACE
                 if  MESSAGE-BUFFER(MSG-LSB:1) = SPACE
                     subtract 1 from MSG-LSB
                 end-if
               end-perform
           end-if
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
